## dde-session-shell 5.4.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)
project(dde-session-shell C CXX)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -g -Wall -pthread -Wl,--as-need -fPIE -Wl,-E")
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS} -O0 -ggdb")
SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -O3")
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

# coverage option
# cmake -DENABLE_COVERAGE=ON ..
OPTION (ENABLE_COVERAGE "Use gcov" OFF)
MESSAGE(STATUS ENABLE_COVERAGE=${ENABLE_COVERAGE})
if (ENABLE_COVERAGE)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
    #SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# Find the library
find_package(PAM REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(DtkWidget5.5 REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Widgets
    Concurrent
    X11Extras
    DBus
    Xml
    Svg
REQUIRED)

pkg_check_modules(XCB_EWMH REQUIRED xcb-ewmh x11 xi xcursor xfixes xrandr xext xtst)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(Greeter REQUIRED liblightdm-qt5-3)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    Qt5::Widgets
    Qt5::X11Extras
    Qt5::Xml
    Qt5::Svg
)

function(generation_dbus_interface xml class_name class_file option)
    execute_process(COMMAND qdbusxml2cpp ${option} -p ${class_file} -c ${class_name} ${xml}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endfunction(generation_dbus_interface)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/com.deepin.daemon.Authenticate.xml
    AuthenticateInterface
    ${CMAKE_CURRENT_BINARY_DIR}/authenticate_interface
    -N
)
set(authority_DBUS_SCRS
    ${CMAKE_CURRENT_BINARY_DIR}/authenticate_interface.h
    ${CMAKE_CURRENT_BINARY_DIR}/authenticate_interface.cpp
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/com.huawei.switchos.xml
    HuaWeiSwitchOSInterface
    ${CMAKE_CURRENT_BINARY_DIR}/switchos_interface
    -N
)
set(haweiswitchos_DBUS_SCRS
    ${CMAKE_CURRENT_BINARY_DIR}/switchos_interface.h
    ${CMAKE_CURRENT_BINARY_DIR}/switchos_interface.cpp
)

include_directories(${PROJECT_SOURCE_DIR}/src/global_util)
include_directories(${PROJECT_SOURCE_DIR}/src/global_util/dbus)
include_directories(${PROJECT_SOURCE_DIR}/src/widgets)
include_directories(${PROJECT_SOURCE_DIR}/src/session-widgets)
include_directories(${PROJECT_SOURCE_DIR}/src/libdde-auth)

aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util GLOBAL_UTILS)
aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/dbus GLOBAL_UTILS_DBUS)
aux_source_directory(${PROJECT_SOURCE_DIR}/src/widgets WIDGETS)
aux_source_directory(${PROJECT_SOURCE_DIR}/src/session-widgets SESSION_WIDGETS)
aux_source_directory(${PROJECT_SOURCE_DIR}/src/libdde-auth AUTHENTICATE)

set(QRCS
    ${PROJECT_SOURCE_DIR}/src/widgets/widgetsimages.qrc
    ${PROJECT_SOURCE_DIR}/src/widgets/widgetstheme.qrc
)
set(LOCK_QRCS
    ${PROJECT_SOURCE_DIR}/src/dde-lock/images.qrc
    ${PROJECT_SOURCE_DIR}/src/dde-lock/logintheme.qrc
)
set(LOCK_SRCS
    ${authority_DBUS_SCRS}
    ${transaction_DBUS_SCRS}
    ${GLOBAL_UTILS}
    ${GLOBAL_UTILS_DBUS}
    ${WIDGETS}
    ${SESSION_WIDGETS}
    ${haweiswitchos_DBUS_SCRS}
    ${AUTHENTICATE}
    src/app/dde-lock.cpp
    src/dde-lock/lockframe.cpp
    src/dde-lock/lockworker.cpp
    src/dde-lock/dbus/dbuslockagent.cpp
    src/dde-lock/dbus/dbuslockfrontservice.cpp
    src/dde-lock/dbus/dbusshutdownagent.cpp
    src/dde-lock/dbus/dbusshutdownfrontservice.cpp
)
add_executable(dde-lock
    ${LOCK_SRCS}
    ${QRCS}
    ${LOCK_QRCS}
)
target_include_directories(dde-lock PUBLIC
    ${PAM_INCLUDE_DIR}
    ${DTKWIDGET5.5_INCLUDE_DIR}
    ${XCB_EWMH_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5X11Extras_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/src/dde-lock
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus
)
target_link_libraries(dde-lock PRIVATE
    ${Qt_LIBS}
    ${PAM_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget5.5_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
)

set(GREETER_QRCS
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logintheme.qrc
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/image.qrc
)
set(GREETER_SRCS
    ${authority_DBUS_SCRS}
    ${transaction_DBUS_SCRS}
    ${GLOBAL_UTILS}
    ${GLOBAL_UTILS_DBUS}
    ${WIDGETS}
    ${SESSION_WIDGETS}
    ${haweiswitchos_DBUS_SCRS}
    ${AUTHENTICATE}
    src/app/lightdm-deepin-greeter.cpp
    src/lightdm-deepin-greeter/loginwindow.cpp
    src/lightdm-deepin-greeter/greeterworkek.cpp
    src/lightdm-deepin-greeter/logincontent.cpp
    src/lightdm-deepin-greeter/logintipswindow.cpp
    src/lightdm-deepin-greeter/sessionwidget.cpp
)
add_executable(lightdm-deepin-greeter
    ${GREETER_SRCS}
    ${QRCS}
    ${GREETER_QRCS}
)
target_include_directories(lightdm-deepin-greeter PUBLIC
    ${PAM_INCLUDE_DIR}
    ${DTKWIDGET5.5_INCLUDE_DIR}
    ${XCB_EWMH_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5X11Extras_INCLUDE_DIRS}
    ${Greeter_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter
)
target_compile_definitions(lightdm-deepin-greeter
    PRIVATE ENABLE_SESSION
)
target_link_libraries(lightdm-deepin-greeter PRIVATE
    ${Qt_LIBS}
    ${PAM_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget5.5_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Greeter_LIBRARIES}
)

add_subdirectory(tests)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# bin
install(TARGETS dde-lock lightdm-deepin-greeter DESTINATION bin)
install(FILES files/deepin-greeter DESTINATION bin)

file(GLOB SCRIPTS  scripts/*)
install(PROGRAMS ${SCRIPTS} DESTINATION /etc/deepin/greeters.d)

file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES}
        DESTINATION share/dde-session-shell/translations)

install(FILES files/lightdm-deepin-greeter.desktop DESTINATION share/xgreeters/)
install(FILES files/dde-lock.desktop DESTINATION share/applications/)
install(FILES files/dde-session-shell.conf DESTINATION share/dde-session-shell/)

# services
file(GLOB SERVICES files/*.service)
install(FILES ${SERVICES} DESTINATION share/dbus-1/services)

#schemas
install(FILES xml/com.deepin.dde.session-shell.gschema.xml DESTINATION share/glib-2.0/schemas)
install(CODE "execute_process(COMMAND glib-compile-schemas ${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas)")

=== tests/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Test DBus REQUIRED)
find_package(GTest REQUIRED)

add_subdirectory(dde-lock)
add_subdirectory(lightdm-deepin-greeter)

=== tests/dde-lock/CMakeLists.txt ===
set(BIN_NAME dde-lock-test)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

aux_source_directory(. LOCK_TEST)

set(LOCK_TEST_SRCS
    ${LOCK_TEST}
    ${authority_DBUS_SCRS}
    ${GLOBAL_UTILS}
    ${GLOBAL_UTILS_DBUS}
    ${WIDGETS}
    ${SESSION_WIDGETS}
    ${haweiswitchos_DBUS_SCRS}
    ${AUTHENTICATE}
    ${PROJECT_SOURCE_DIR}/src/dde-lock/lockframe.cpp
    ${PROJECT_SOURCE_DIR}/src/dde-lock/lockworker.cpp
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus/dbuslockagent.cpp
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus/dbuslockfrontservice.cpp
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus/dbusshutdownagent.cpp
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus/dbusshutdownfrontservice.cpp
)

add_executable(${BIN_NAME}
    ${LOCK_TEST_SRCS}
    ${QRCS}
    ${LOCK_QRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
    ${DTKWIDGET5.5_INCLUDE_DIR}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${PAM_INCLUDE_DIR}
    ${XCB_EWMH_INCLUDE_DIRS}
    ${Qt5X11Extras_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}/src/dde-lock
    ${PROJECT_SOURCE_DIR}/src/dde-lock/dbus
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt5Test_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget5.5_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${Qt_LIBS}
    ${PAM_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    -lpthread
    -lm
)

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
set(BIN_NAME lightdm-deepin-greeter-test)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

aux_source_directory(. GREETER_TEST)

set(GREETER_TEST_SRCS
    ${GREETER_TEST}
    ${authority_DBUS_SCRS}
    ${transaction_DBUS_SCRS}
    ${GLOBAL_UTILS}
    ${GLOBAL_UTILS_DBUS}
    ${WIDGETS}
    ${SESSION_WIDGETS}
    ${haweiswitchos_DBUS_SCRS}
    ${AUTHENTICATE}
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/loginwindow.cpp
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/greeterworkek.cpp
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logincontent.cpp
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logintipswindow.cpp
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/sessionwidget.cpp
)

add_executable(${BIN_NAME}
    ${GREETER_TEST_SRCS}
    ${QRCS}
    ${GREETER_QRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
    ${PAM_INCLUDE_DIR}
    ${DTKWIDGET5.5_INCLUDE_DIR}
    ${XCB_EWMH_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5X11Extras_INCLUDE_DIRS}
    ${Greeter_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter
)

target_compile_definitions(lightdm-deepin-greeter
    PRIVATE ENABLE_SESSION
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${PAM_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget5.5_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Greeter_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
    -lm
)

=== debian/changelog ===
dde-session-shell (5.4.13-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Wed, 14 Apr 2021 17:45:50 +0800

dde-session-shell (0.0.0) unstable; urgency=medium

  * Initialize release

 --  <songwenwu@linuxdeepin.com>  Tue, 02 Dec 2014 11:47:15 +0800

=== debian/control ===
Source: dde-session-shell
Section: devel
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends: debhelper (>= 8.0.0), pkg-config,
 cmake,
 qtbase5-dev,
 liblightdm-qt5-3-dev | liblightdm-qt-dev,
 libxcb-ewmh-dev,
 libqt5x11extras5-dev,
 libgsettings-qt-dev,
 libqt5svg5-dev,
 libglib2.0-dev,
 libdtkwidget-dev,
 libdtkwidget5.5-dev,
 qtdeclarative5-dev,
 qttools5-dev-tools,
 libpam0g-dev,libsystemd-dev,
 libdframeworkdbus-dev,
 deepin-gettext-tools,
 libxtst-dev,
 libxcursor-dev,
 libxrandr-dev,
 libdtkcore5-bin,
 libgtest-dev,
 libx11-xcb-dev
Standards-Version: 3.9.4
Homepage: http://www.deepin.org/

Package: dde-session-shell
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dist:Depends},
 deepin-desktop-schemas (>=5.8.0.34),
 libdframeworkdbus2 (>=5.4.2),
 dde-daemon (>=5.12.0.31),
 startdde (>=5.6.0.34),
 x11-xserver-utils,
 dbus-x11,
 deepin-authenticate(>=1.0.0.2),
 xsettingsd
Provides: lightdm-greeter
Recommends: onboard
Conflicts: dde-workspace,
 deepin-notifications,
 dde-session-ui (<< 5.0.0)
Replaces: deepin-notifications
Breaks: dde-workspace
Description: deepin desktop-environment - dde-session-shell module
 Deepin desktop environment 2015 - dde-session-shell module.
 lightdm-deepin-greeter - login，the entry to the desktop
 dde-lock - lock screen, to protect privacy
 deepin-greeter - actual call the lightdm-deepin-greeter

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export QT_SELECT=5

include /usr/share/dpkg/default.mk
SYSTYPE=Desktop
SYSTYPE=$(shell cat /etc/deepin-version | grep Type= | awk -F'=' '{print $$2}')
%:
	dh $@ --parallel

ifeq ($(DEB_BUILD_ARCH), mipsel)
override_dh_auto_configure:
	dh_auto_configure -- LOCK_NO_QUIT=YES DISABLE_DEMO_VIDEO=YES DISABLE_TEXT_SHADOW=YES DISABLE_ANIMATIONS=YES USE_CURSOR_LOADING_ANI=YES
endif

ifeq ($(DEB_BUILD_ARCH), mips64el)
override_dh_auto_configure:
	dh_auto_configure -- LOCK_NO_QUIT=YES DISABLE_DEMO_VIDEO=YES DISABLE_TEXT_SHADOW=YES DISABLE_ANIMATIONS=YES USE_CURSOR_LOADING_ANI=YES
endif

ifeq ($(DEB_BUILD_ARCH), sw_64)
override_dh_auto_configure:
	dh_auto_configure -- LOCK_NO_QUIT=YES DISABLE_DEMO_VIDEO=YES DISABLE_TEXT_SHADOW=YES DISABLE_ANIMATIONS=YES USE_CURSOR_LOADING_ANI=YES
endif

ifeq ($(SYSTYPE), Professional)
ifeq ($(DEB_BUILD_ARCH), amd64)
override_dh_gencontrol:
	dh_gencontrol -- -Vdist:Depends="pbis-open"
endif
endif

## dde-session-shell 5.5.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,11 @@
 SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS} -O0 -ggdb")
 SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -O3")
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
+
+# 增加安全编译参数
+set(SECURITY_COMPILE, "-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+set(CMAKE_CXX_FLAGS, "${CMAKE_CXX_FLAGS} ${SECURITY_COMPILE}")
+set(CMAKE_C_FLAGS, "${CMAKE_C_FLAGS} ${SECURITY_COMPILE}")
 
 # coverage option
 # cmake -DENABLE_COVERAGE=ON ..
@@ -37,8 +42,9 @@
 # Find the library
 find_package(PAM REQUIRED)
 find_package(PkgConfig REQUIRED)
-find_package(DtkWidget5.5 REQUIRED)
-find_package(DtkCMake REQUIRED)
+find_package(DtkWidget REQUIRED)
+find_package(DtkCMake  REQUIRED)
+find_package(DtkCore REQUIRED)
 find_package(Qt5 COMPONENTS
     Core
     Widgets
@@ -47,6 +53,7 @@
     DBus
     Xml
     Svg
+    Network
 REQUIRED)
 
 pkg_check_modules(XCB_EWMH REQUIRED xcb-ewmh x11 xi xcursor xfixes xrandr xext xtst)
@@ -93,33 +100,37 @@
 
 include_directories(${PROJECT_SOURCE_DIR}/src/global_util)
 include_directories(${PROJECT_SOURCE_DIR}/src/global_util/dbus)
+include_directories(${PROJECT_SOURCE_DIR}/src/global_util/keyboardmonitor)
 include_directories(${PROJECT_SOURCE_DIR}/src/widgets)
 include_directories(${PROJECT_SOURCE_DIR}/src/session-widgets)
 include_directories(${PROJECT_SOURCE_DIR}/src/libdde-auth)
+include_directories(${PROJECT_SOURCE_DIR}/interface)
 
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util GLOBAL_UTILS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/dbus GLOBAL_UTILS_DBUS)
+aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/keyboardmonitor GLOBAL_UTILS_KEYBOARDMONITOR)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/widgets WIDGETS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/session-widgets SESSION_WIDGETS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/libdde-auth AUTHENTICATE)
+aux_source_directory(${PROJECT_SOURCE_DIR}/interface INTERFACE)
 
 set(QRCS
+    ${CMAKE_CURRENT_SOURCE_DIR}/resources.qrc
     ${PROJECT_SOURCE_DIR}/src/widgets/widgetsimages.qrc
     ${PROJECT_SOURCE_DIR}/src/widgets/widgetstheme.qrc
 )
-set(LOCK_QRCS
-    ${PROJECT_SOURCE_DIR}/src/dde-lock/images.qrc
-    ${PROJECT_SOURCE_DIR}/src/dde-lock/logintheme.qrc
-)
+
 set(LOCK_SRCS
     ${authority_DBUS_SCRS}
     ${transaction_DBUS_SCRS}
     ${GLOBAL_UTILS}
     ${GLOBAL_UTILS_DBUS}
+    ${GLOBAL_UTILS_KEYBOARDMONITOR}
     ${WIDGETS}
     ${SESSION_WIDGETS}
     ${haweiswitchos_DBUS_SCRS}
     ${AUTHENTICATE}
+    ${INTERFACE}
     src/app/dde-lock.cpp
     src/dde-lock/lockframe.cpp
     src/dde-lock/lockworker.cpp
@@ -131,11 +142,11 @@
 add_executable(dde-lock
     ${LOCK_SRCS}
     ${QRCS}
-    ${LOCK_QRCS}
 )
 target_include_directories(dde-lock PUBLIC
     ${PAM_INCLUDE_DIR}
-    ${DTKWIDGET5.5_INCLUDE_DIR}
+    ${DTKWIDGET_INCLUDE_DIR}
+    ${DTKCORE_INCLUDE_DIR}
     ${XCB_EWMH_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
@@ -150,7 +161,8 @@
     ${PAM_LIBRARIES}
     ${XCB_EWMH_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
-    ${DtkWidget5.5_LIBRARIES}
+    ${DtkWidget_LIBRARIES}
+    ${DtkCore_LIBRARIES}
     ${Qt5Widgets_LIBRARIES}
     ${Qt5Concurrent_LIBRARIES}
     ${Qt5X11Extras_LIBRARIES}
@@ -159,22 +171,20 @@
     ${QGSettings_LIBRARIES}
 )
 
-set(GREETER_QRCS
-    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logintheme.qrc
-    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/image.qrc
-)
 set(GREETER_SRCS
     ${authority_DBUS_SCRS}
     ${transaction_DBUS_SCRS}
     ${GLOBAL_UTILS}
     ${GLOBAL_UTILS_DBUS}
+    ${GLOBAL_UTILS_KEYBOARDMONITOR}
     ${WIDGETS}
     ${SESSION_WIDGETS}
     ${haweiswitchos_DBUS_SCRS}
     ${AUTHENTICATE}
+    ${INTERFACE}
     src/app/lightdm-deepin-greeter.cpp
     src/lightdm-deepin-greeter/loginwindow.cpp
-    src/lightdm-deepin-greeter/greeterworkek.cpp
+    src/lightdm-deepin-greeter/greeterworker.cpp
     src/lightdm-deepin-greeter/logincontent.cpp
     src/lightdm-deepin-greeter/logintipswindow.cpp
     src/lightdm-deepin-greeter/sessionwidget.cpp
@@ -182,11 +192,11 @@
 add_executable(lightdm-deepin-greeter
     ${GREETER_SRCS}
     ${QRCS}
-    ${GREETER_QRCS}
 )
 target_include_directories(lightdm-deepin-greeter PUBLIC
     ${PAM_INCLUDE_DIR}
-    ${DTKWIDGET5.5_INCLUDE_DIR}
+    ${DTKWIDGET_INCLUDE_DIR}
+    ${DTKCORE_INCLUDE_DIR}
     ${XCB_EWMH_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
@@ -204,7 +214,8 @@
     ${PAM_LIBRARIES}
     ${XCB_EWMH_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
-    ${DtkWidget5.5_LIBRARIES}
+    ${DtkWidget_LIBRARIES}
+    ${DtkCore_LIBRARIES}
     ${Qt5Widgets_LIBRARIES}
     ${Qt5Concurrent_LIBRARIES}
     ${Qt5X11Extras_LIBRARIES}
@@ -214,6 +225,11 @@
     ${Greeter_LIBRARIES}
 )
 
+# debug模式下增加示例demo的编译
+if ((${CMAKE_BUILD_TYPE} MATCHES "Debug"))
+    add_subdirectory(modules)
+endif ()
+
 add_subdirectory(tests)
 
 # Install settings
@@ -229,12 +245,13 @@
 install(PROGRAMS ${SCRIPTS} DESTINATION /etc/deepin/greeters.d)
 
 file(GLOB QM_FILES "translations/*.qm")
-install(FILES ${QM_FILES}
-        DESTINATION share/dde-session-shell/translations)
+install(FILES ${QM_FILES} DESTINATION share/dde-session-shell/translations)
+install(FILES qt-theme.ini DESTINATION /etc/lightdm/deepin)
 
 install(FILES files/lightdm-deepin-greeter.desktop DESTINATION share/xgreeters/)
 install(FILES files/dde-lock.desktop DESTINATION share/applications/)
 install(FILES files/dde-session-shell.conf DESTINATION share/dde-session-shell/)
+install(FILES files/lightdm-deepin-greeter.conf DESTINATION share/deepin-authentication/privileges/)
 
 # services
 file(GLOB SERVICES files/*.service)
@@ -242,4 +259,14 @@
 
 #schemas
 install(FILES xml/com.deepin.dde.session-shell.gschema.xml DESTINATION share/glib-2.0/schemas)
-install(CODE "execute_process(COMMAND glib-compile-schemas ${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas)")
+
+# dev
+file(GLOB INTERFACE interface/*.h)
+install(FILES ${INTERFACE} DESTINATION include/dde-session-shell)
+
+file(GLOB CMAKE_CONFIG cmake/*.cmake)
+install(FILES ${CMAKE_CONFIG} DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeSessionShell)
+
+# config
+dconfig_meta_files(APPID dde-lock FILES configs/com.deepin.dde.dde-lock.dconfig.json)
+dconfig_meta_files(APPID lightdm-deepin-greeter FILES configs/com.deepin.dde.lightdm-deepin-greeter.dconfig.json)

=== modules/examples/CMakeLists.txt ===
# add_subdirectory(login)
add_subdirectory(network)
#add_subdirectory(webview)

=== tests/dde-lock/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
 set(BIN_NAME dde-lock-test)
-
-# 用于测试覆盖率的编译条件
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
 
 aux_source_directory(. LOCK_TEST)
 
@@ -10,6 +7,7 @@
     ${authority_DBUS_SCRS}
     ${GLOBAL_UTILS}
     ${GLOBAL_UTILS_DBUS}
+    ${GLOBAL_UTILS_KEYBOARDMONITOR}
     ${WIDGETS}
     ${SESSION_WIDGETS}
     ${haweiswitchos_DBUS_SCRS}
@@ -29,7 +27,8 @@
 )
 
 target_include_directories(${BIN_NAME} PUBLIC
-    ${DTKWIDGET5.5_INCLUDE_DIR}
+    ${DTKWIDGET_INCLUDE_DIR}
+    ${DTKCORE_INCLUDE_DIR}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
     ${QGSettings_INCLUDE_DIRS}
@@ -44,7 +43,8 @@
 target_link_libraries(${BIN_NAME} PRIVATE
     ${Qt5Test_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
-    ${DtkWidget5.5_LIBRARIES}
+    ${DtkWidget_LIBRARIES}
+    ${DtkCore_LIBRARIES}
     ${Qt5Widgets_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
     ${QGSettings_LIBRARIES}

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
 set(BIN_NAME lightdm-deepin-greeter-test)
-
-# 用于测试覆盖率的编译条件
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
 
 aux_source_directory(. GREETER_TEST)
 
@@ -11,12 +8,13 @@
     ${transaction_DBUS_SCRS}
     ${GLOBAL_UTILS}
     ${GLOBAL_UTILS_DBUS}
+    ${GLOBAL_UTILS_KEYBOARDMONITOR}
     ${WIDGETS}
     ${SESSION_WIDGETS}
     ${haweiswitchos_DBUS_SCRS}
     ${AUTHENTICATE}
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/loginwindow.cpp
-    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/greeterworkek.cpp
+    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/greeterworker.cpp
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logincontent.cpp
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logintipswindow.cpp
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/sessionwidget.cpp
@@ -30,7 +28,8 @@
 
 target_include_directories(${BIN_NAME} PUBLIC
     ${PAM_INCLUDE_DIR}
-    ${DTKWIDGET5.5_INCLUDE_DIR}
+    ${DTKWIDGET_INCLUDE_DIR}
+    ${DTKCORE_INCLUDE_DIR}
     ${XCB_EWMH_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
@@ -50,7 +49,8 @@
     ${PAM_LIBRARIES}
     ${XCB_EWMH_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
-    ${DtkWidget5.5_LIBRARIES}
+    ${DtkWidget_LIBRARIES}
+    ${DtkCore_LIBRARIES}
     ${Qt5Widgets_LIBRARIES}
     ${Qt5Concurrent_LIBRARIES}
     ${Qt5X11Extras_LIBRARIES}

=== debian/changelog ===
dde-session-shell (5.5.14-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Mon, 21 Feb 2022 11:27:49 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libqt5svg5-dev,
  libglib2.0-dev,
  libdtkwidget-dev,
- libdtkwidget5.5-dev,
+ libdtkcore5-bin,
  qtdeclarative5-dev,
  qttools5-dev-tools,
  libpam0g-dev,libsystemd-dev,
@@ -23,26 +23,34 @@
  libxrandr-dev,
  libdtkcore5-bin,
  libgtest-dev,
- libx11-xcb-dev
+ libx11-xcb-dev,
+ libssl-dev,
+ libdtkcore-dev,
+ qtwebengine5-dev
 Standards-Version: 3.9.4
 Homepage: http://www.deepin.org/
 
 Package: dde-session-shell
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${dist:Depends},
- deepin-desktop-schemas (>=5.8.0.34),
- libdframeworkdbus2 (>=5.4.2),
- dde-daemon (>=5.12.0.31),
- startdde (>=5.6.0.34),
+ deepin-desktop-schemas (>=5.9.14),
+ libdframeworkdbus2 (>=5.4.10),
+ dde-daemon (>=5.13.12),
+ startdde (>=5.8.9),
  x11-xserver-utils,
  dbus-x11,
- deepin-authenticate(>=1.0.0.2),
- xsettingsd
+ deepin-authenticate(>=1.2.27),
+ xsettingsd,
+ libssl-dev,
+ libxcb-util0
 Provides: lightdm-greeter
-Recommends: onboard
+Recommends: onboard,
+ dss-network-plugin,
+ dde-network-dialog
 Conflicts: dde-workspace,
  deepin-notifications,
- dde-session-ui (<< 5.0.0)
+ dde-session-ui (<< 5.0.0),
+ dde-preload
 Replaces: deepin-notifications
 Breaks: dde-workspace
 Description: deepin desktop-environment - dde-session-shell module
@@ -50,3 +58,15 @@
  lightdm-deepin-greeter - login，the entry to the desktop
  dde-lock - lock screen, to protect privacy
  deepin-greeter - actual call the lightdm-deepin-greeter
+
+Package: dde-session-shell-dev
+Architecture: any
+Depends: dde-session-shell (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Description: deepin desktop-environment - dde-session-shell module development files
+ DDE Session Shell module development files of deepin desktop-environment
+
+Package: deepin-greeter-wayland
+Architecture: any
+Depends: dde-session-shell (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, dde-wayland-config
+Description: deepin desktop-environment - dde-session-shell module config files
+ DDE Session Shell module configuration package adapted to the wayland environment for lightdm-deepin-greeter

## dde-session-shell 5.5.34

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
 
 # 增加安全编译参数
-set(SECURITY_COMPILE, "-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+set(SECURITY_COMPILE, "-fstack-protector-all -fPIC")
 set(CMAKE_CXX_FLAGS, "${CMAKE_CXX_FLAGS} ${SECURITY_COMPILE}")
 set(CMAKE_C_FLAGS, "${CMAKE_C_FLAGS} ${SECURITY_COMPILE}")
 
@@ -29,7 +29,7 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
 endif()
 
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")
 
 if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
@@ -209,6 +209,13 @@
 target_compile_definitions(lightdm-deepin-greeter
     PRIVATE ENABLE_SESSION
 )
+
+if (WAIT_DEEPIN_ACCOUNTS_SERVICE)
+    target_compile_definitions(lightdm-deepin-greeter
+        PUBLIC ENABLE_WAITING_ACCOUNTS_SERVICE
+    )
+endif()
+
 target_link_libraries(lightdm-deepin-greeter PRIVATE
     ${Qt_LIBS}
     ${PAM_LIBRARIES}
@@ -225,11 +232,6 @@
     ${Greeter_LIBRARIES}
 )
 
-# debug模式下增加示例demo的编译
-if ((${CMAKE_BUILD_TYPE} MATCHES "Debug"))
-    add_subdirectory(modules)
-endif ()
-
 add_subdirectory(tests)
 
 # Install settings
@@ -268,5 +270,5 @@
 install(FILES ${CMAKE_CONFIG} DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeSessionShell)
 
 # config
-dconfig_meta_files(APPID dde-lock FILES configs/com.deepin.dde.dde-lock.dconfig.json)
-dconfig_meta_files(APPID lightdm-deepin-greeter FILES configs/com.deepin.dde.lightdm-deepin-greeter.dconfig.json)
+dconfig_meta_files(APPID org.deepin.dde.lock FILES configs/org.deepin.dde.lock.json)
+dconfig_meta_files(APPID org.deepin.dde.lightdm-deepin-greeter FILES configs/org.deepin.dde.lightdm-deepin-greeter.json)

=== modules/examples/login/CMakeLists.txt ===
include_directories(
    ${DFrameworkDBus_INCLUDE_DIRS}
    global
)

link_libraries(
    ${Qt_LIBS}
)

set(LIB_NAME login)

aux_source_directory(. SRCS)

# add_library(${LIB_NAME} STATIC ${SRCS})

add_library(${LIB_NAME} SHARED ${SRCS})

install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)

=== modules/examples/network/CMakeLists.txt ===
include_directories(
    ${DFrameworkDBus_INCLUDE_DIRS}
    global
)

link_libraries(
    ${Qt_LIBS}
)

set(LIB_NAME network)

aux_source_directory(. SRCS)

# add_library(${LIB_NAME} STATIC ${SRCS})

add_library(${LIB_NAME} SHARED ${SRCS})

install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)

=== debian/changelog ===
dde-session-shell (5.5.34-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Mon, 16 May 2022 16:42:01 +0800

=== debian/control ===
--- 
+++ 
@@ -25,8 +25,7 @@
  libgtest-dev,
  libx11-xcb-dev,
  libssl-dev,
- libdtkcore-dev,
- qtwebengine5-dev
+ libdtkcore-dev
 Standards-Version: 3.9.4
 Homepage: http://www.deepin.org/

## dde-session-shell 5.5.50

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
 find_package(DtkWidget REQUIRED)
 find_package(DtkCMake  REQUIRED)
 find_package(DtkCore REQUIRED)
+find_package(KF5Wayland REQUIRED)
 find_package(Qt5 COMPONENTS
     Core
     Widgets
@@ -169,6 +170,7 @@
     ${Qt5DBus_LIBRARIES}
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
+    KF5::WaylandClient
 )
 
 set(GREETER_SRCS
@@ -230,6 +232,7 @@
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
     ${Greeter_LIBRARIES}
+    KF5::WaylandClient
 )
 
 add_subdirectory(tests)

=== modules/CMakeLists.txt ===
add_subdirectory(examples)
add_subdirectory(login)

=== modules/login/CMakeLists.txt ===
find_package(QT NAMES Qt6 Qt5 COMPONENTS Widgets WebEngineWidgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets WebEngineWidgets REQUIRED)

include_directories(
    ${DFrameworkDBus_INCLUDE_DIRS}
    global
)

link_libraries(
    ${Qt_LIBS}
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::WebEngineWidgets
)

set(LIB_NAME login)

aux_source_directory(. SRCS)

# add_library(${LIB_NAME} STATIC ${SRCS})

add_library(${LIB_NAME} SHARED ${SRCS})

install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,7 @@
     ${Greeter_LIBRARIES}
     ${Qt5Test_LIBRARIES}
     ${GTEST_LIBRARIES}
+    KF5::WaylandClient
     -lpthread
     -lm
 )

=== debian/changelog ===
dde-session-shell (5.5.50-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Mon, 27 Jun 2022 10:42:03 +0800

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,8 @@
  libgtest-dev,
  libx11-xcb-dev,
  libssl-dev,
- libdtkcore-dev
+ libdtkcore-dev,
+ libkf5wayland-dev
 Standards-Version: 3.9.4
 Homepage: http://www.deepin.org/

=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,10 @@
 	dh_auto_configure -- LOCK_NO_QUIT=YES DISABLE_DEMO_VIDEO=YES DISABLE_TEXT_SHADOW=YES DISABLE_ANIMATIONS=YES USE_CURSOR_LOADING_ANI=YES
 endif
 
+override_dh_auto_configure:
+	dh_auto_configure -- \
+		-DWAIT_DEEPIN_ACCOUNTS_SERVICE=1
+
 ifeq ($(SYSTYPE), Professional)
 ifeq ($(DEB_BUILD_ARCH), amd64)
 override_dh_gencontrol:

## dde-session-shell 5.5.66

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,14 @@
 cmake_minimum_required(VERSION 3.13.4)
 project(dde-session-shell C CXX)
+
+include(GNUInstallDirs)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -g -Wall -pthread -Wl,--as-need -fPIE -Wl,-E")
-SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS} -O0 -ggdb")
-SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -O3")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -g -Wall")
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
-
-# 增加安全编译参数
-set(SECURITY_COMPILE, "-fstack-protector-all -fPIC")
-set(CMAKE_CXX_FLAGS, "${CMAKE_CXX_FLAGS} ${SECURITY_COMPILE}")
-set(CMAKE_C_FLAGS, "${CMAKE_C_FLAGS} ${SECURITY_COMPILE}")
 
 # coverage option
 # cmake -DENABLE_COVERAGE=ON ..
@@ -29,7 +24,7 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
 endif()
 
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")
+#set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")
 
 if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
@@ -46,6 +41,7 @@
 find_package(DtkCMake  REQUIRED)
 find_package(DtkCore REQUIRED)
 find_package(KF5Wayland REQUIRED)
+find_package(Threads REQUIRED)
 find_package(Qt5 COMPONENTS
     Core
     Widgets
@@ -72,6 +68,22 @@
     Qt5::Svg
 )
 
+try_compile(USE_DEEPIN_WAYLAND
+              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
+            SOURCES
+              ${CMAKE_CURRENT_SOURCE_DIR}/tests/wayland_test.cc
+            LINK_LIBRARIES
+              ${Qt_LIBS}
+              ${Qt5Widgets_LIBRARIES}
+              KF5::WaylandClient
+)
+
+message(STATUS "USE_DEEPIN_WAYLAND ${USE_DEEPIN_WAYLAND}")
+
+if(USE_DEEPIN_WAYLAND)
+  add_definitions(-DUSE_DEEPIN_WAYLAND)
+endif()
+
 function(generation_dbus_interface xml class_name class_file option)
     execute_process(COMMAND qdbusxml2cpp ${option} -p ${class_file} -c ${class_name} ${xml}
     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
@@ -109,10 +121,10 @@
 
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util GLOBAL_UTILS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/dbus GLOBAL_UTILS_DBUS)
-aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/keyboardmonitor GLOBAL_UTILS_KEYBOARDMONITOR)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/widgets WIDGETS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/session-widgets SESSION_WIDGETS)
 aux_source_directory(${PROJECT_SOURCE_DIR}/src/libdde-auth AUTHENTICATE)
+aux_source_directory(${PROJECT_SOURCE_DIR}/src/global_util/keyboardmonitor GLOBAL_UTILS_KEYBOARDMONITOR)
 aux_source_directory(${PROJECT_SOURCE_DIR}/interface INTERFACE)
 
 set(QRCS
@@ -140,6 +152,11 @@
     src/dde-lock/dbus/dbusshutdownagent.cpp
     src/dde-lock/dbus/dbusshutdownfrontservice.cpp
 )
+
+link_libraries(
+    Threads::Threads
+)
+
 add_executable(dde-lock
     ${LOCK_SRCS}
     ${QRCS}
@@ -191,6 +208,14 @@
     src/lightdm-deepin-greeter/logintipswindow.cpp
     src/lightdm-deepin-greeter/sessionwidget.cpp
 )
+
+if (USE_DEEPIN_WAYLAND)
+  set(GREETER_SRCS
+    ${GREETER_SRCS}
+    src/lightdm-deepin-greeter/greeter_display_wayland.cpp
+  )
+endif(USE_DEEPIN_WAYLAND)
+
 add_executable(lightdm-deepin-greeter
     ${GREETER_SRCS}
     ${QRCS}
@@ -236,6 +261,7 @@
 )
 
 add_subdirectory(tests)
+add_subdirectory(plugins)
 
 # Install settings
 if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -255,6 +281,7 @@
 
 install(FILES files/lightdm-deepin-greeter.desktop DESTINATION share/xgreeters/)
 install(FILES files/dde-lock.desktop DESTINATION share/applications/)
+install(FILES files/dde-lock.desktop DESTINATION /etc/xdg/autostart/)
 install(FILES files/dde-session-shell.conf DESTINATION share/dde-session-shell/)
 install(FILES files/lightdm-deepin-greeter.conf DESTINATION share/deepin-authentication/privileges/)

=== plugins/one-key-login/CMakeLists.txt ===
find_package(QT NAMES Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)

link_libraries(
    ${Qt_LIBS}
    Qt${QT_VERSION_MAJOR}::Widgets
)

set(LIB_NAME one-key-login)

aux_source_directory(. SRCS)

add_library(${LIB_NAME} SHARED ${SRCS})

install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)

=== tests/dde-lock/CMakeLists.txt ===
--- 
+++ 
@@ -55,6 +55,7 @@
     ${Qt5Concurrent_LIBRARIES}
     ${Qt5X11Extras_LIBRARIES}
     ${Qt5Network_LIBRARIES}
+    KF5::WaylandClient
     -lpthread
     -lm
 )

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,12 @@
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/logintipswindow.cpp
     ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/sessionwidget.cpp
 )
+if (USE_DEEPIN_WAYLAND)
+  set(GREETER_TEST_SRCS
+    ${GREETER_TEST_SRCS}
+    ${PROJECT_SOURCE_DIR}/src/lightdm-deepin-greeter/greeter_display_wayland.cpp
+  )
+endif(USE_DEEPIN_WAYLAND)
 
 add_executable(${BIN_NAME}
     ${GREETER_TEST_SRCS}

=== plugins/examples/login-plugins/login-basic/CMakeLists.txt ===
find_package(QT NAMES Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)

link_libraries(
    ${Qt_LIBS}
    Qt${QT_VERSION_MAJOR}::Widgets
)

set(LIB_NAME login-basic)

aux_source_directory(. SRCS)

add_library(${LIB_NAME} SHARED ${SRCS})

install(TARGETS ${LIB_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)

=== debian/changelog ===
dde-session-shell (5.5.66-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Sat, 13 Aug 2022 13:45:20 +0800

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
  deepin-authenticate(>=1.2.27),
  xsettingsd,
  libssl-dev,
- libxcb-util0
+ libxcb-util0 | libxcb-util1
 Provides: lightdm-greeter
 Recommends: onboard,
  dss-network-plugin,

## dde-session-shell 5.5.69

=== CMakeLists.txt ===
--- 
+++ 
@@ -83,6 +83,8 @@
 if(USE_DEEPIN_WAYLAND)
   add_definitions(-DUSE_DEEPIN_WAYLAND)
 endif()
+# 优先使用国密
+add_definitions(-DPREFER_USING_GM)
 
 function(generation_dbus_interface xml class_name class_file option)
     execute_process(COMMAND qdbusxml2cpp ${option} -p ${class_file} -c ${class_name} ${xml}
@@ -188,6 +190,7 @@
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
     KF5::WaylandClient
+    -lcrypto
 )
 
 set(GREETER_SRCS
@@ -258,6 +261,7 @@
     ${QGSettings_LIBRARIES}
     ${Greeter_LIBRARIES}
     KF5::WaylandClient
+    -lcrypto
 )
 
 add_subdirectory(tests)

=== tests/dde-lock/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 set(BIN_NAME dde-lock-test)
 
 aux_source_directory(. LOCK_TEST)
+
+# 优先使用国密
+add_definitions(-DPREFER_USING_GM)
 
 set(LOCK_TEST_SRCS
     ${LOCK_TEST}
@@ -58,4 +61,5 @@
     KF5::WaylandClient
     -lpthread
     -lm
+    -lcrypto
 )

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 set(BIN_NAME lightdm-deepin-greeter-test)
 
 aux_source_directory(. GREETER_TEST)
+
+# 优先使用国密
+add_definitions(-DPREFER_USING_GM)
 
 set(GREETER_TEST_SRCS
     ${GREETER_TEST}
@@ -69,4 +72,5 @@
     KF5::WaylandClient
     -lpthread
     -lm
+    -lcrypto
 )

=== debian/changelog ===
dde-session-shell (5.5.69-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Sat, 27 Aug 2022 10:33:08 +0800

## dde-session-shell 5.5.73

=== plugins/CMakeLists.txt ===
add_subdirectory(one-key-login)
#add_subdirectory(examples)

=== tests/lightdm-deepin-greeter/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 set(BIN_NAME lightdm-deepin-greeter-test)
 
 aux_source_directory(. GREETER_TEST)
-
-# 优先使用国密
-add_definitions(-DPREFER_USING_GM)
 
 set(GREETER_TEST_SRCS
     ${GREETER_TEST}

=== debian/changelog ===
dde-session-shell (5.5.73-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 15 Sep 2022 13:08:32 +0800

## dde-session-shell 5.5.81

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
 project(dde-session-shell C CXX)
 
 include(GNUInstallDirs)
+if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+    set(CMAKE_INSTALL_PREFIX /usr)
+endif ()
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -57,6 +60,7 @@
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 pkg_check_modules(QGSettings REQUIRED gsettings-qt)
 pkg_check_modules(Greeter REQUIRED liblightdm-qt5-3)
+pkg_check_modules(SSL REQUIRED IMPORTED_TARGET libcrypto libssl openssl)
 
 set(Qt_LIBS
     Qt5::Core
@@ -83,8 +87,28 @@
 if(USE_DEEPIN_WAYLAND)
   add_definitions(-DUSE_DEEPIN_WAYLAND)
 endif()
-# 优先使用国密
-add_definitions(-DPREFER_USING_GM)
+
+
+try_compile(USE_GM
+              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
+            SOURCES
+              ${CMAKE_CURRENT_SOURCE_DIR}/tests/test_gm.cc
+            LINK_LIBRARIES
+	      PkgConfig::SSL
+	    OUTPUT_VARIABLE
+	      GM_MESSAGE
+)
+
+message(STATUS "check GM: ${USE_GM}")
+
+if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
+    message(${GM_MESSAGE})
+endif()
+
+if(USE_GM)
+  # 优先使用国密
+  add_definitions(-DPREFER_USING_GM)
+endif()
 
 function(generation_dbus_interface xml class_name class_file option)
     execute_process(COMMAND qdbusxml2cpp ${option} -p ${class_file} -c ${class_name} ${xml}
@@ -190,7 +214,7 @@
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
     KF5::WaylandClient
-    -lcrypto
+    PkgConfig::SSL
 )
 
 set(GREETER_SRCS
@@ -261,45 +285,46 @@
     ${QGSettings_LIBRARIES}
     ${Greeter_LIBRARIES}
     KF5::WaylandClient
-    -lcrypto
+    PkgConfig::SSL
 )
 
 add_subdirectory(tests)
 add_subdirectory(plugins)
 
 # Install settings
-if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
-    set(CMAKE_INSTALL_PREFIX /usr)
-endif ()
 
 # bin
-install(TARGETS dde-lock lightdm-deepin-greeter DESTINATION bin)
-install(FILES files/deepin-greeter DESTINATION bin)
+install(TARGETS dde-lock lightdm-deepin-greeter DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(FILES files/deepin-greeter DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 file(GLOB SCRIPTS  scripts/*)
-install(PROGRAMS ${SCRIPTS} DESTINATION /etc/deepin/greeters.d)
+install(PROGRAMS ${SCRIPTS} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/deepin/greeters.d)
 
 file(GLOB QM_FILES "translations/*.qm")
-install(FILES ${QM_FILES} DESTINATION share/dde-session-shell/translations)
-install(FILES qt-theme.ini DESTINATION /etc/lightdm/deepin)
-
-install(FILES files/lightdm-deepin-greeter.desktop DESTINATION share/xgreeters/)
-install(FILES files/dde-lock.desktop DESTINATION share/applications/)
-install(FILES files/dde-lock.desktop DESTINATION /etc/xdg/autostart/)
-install(FILES files/dde-session-shell.conf DESTINATION share/dde-session-shell/)
-install(FILES files/lightdm-deepin-greeter.conf DESTINATION share/deepin-authentication/privileges/)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-session-shell/translations)
+install(FILES qt-theme.ini DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/lightdm/deepin)
+
+install(FILES files/lightdm-deepin-greeter.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/xgreeters/)
+install(FILES files/dde-lock.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
+install(FILES files/dde-lock.desktop DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart/)
+install(FILES files/dde-session-shell.conf DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-session-shell/)
+install(FILES files/lightdm-deepin-greeter.conf DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-authentication/privileges/)
 
 # services
 file(GLOB SERVICES files/*.service)
-install(FILES ${SERVICES} DESTINATION share/dbus-1/services)
+install(FILES ${SERVICES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)
 
 #schemas
-install(FILES xml/com.deepin.dde.session-shell.gschema.xml DESTINATION share/glib-2.0/schemas)
+install(FILES xml/com.deepin.dde.session-shell.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)
 
 # dev
 file(GLOB INTERFACE interface/*.h)
-install(FILES ${INTERFACE} DESTINATION include/dde-session-shell)
-
+install(FILES ${INTERFACE} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-session-shell)
+
+configure_file(
+    ${CMAKE_SOURCE_DIR}/cmake/DdeSessionShellConfig.cmake.in
+    ${CMAKE_SOURCE_DIR}/cmake/DdeSessionShellConfig.cmake
+    @ONLY)
 file(GLOB CMAKE_CONFIG cmake/*.cmake)
 install(FILES ${CMAKE_CONFIG} DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeSessionShell)

=== plugins/examples/CMakeLists.txt ===
add_subdirectory(login-plugins/login-basic)
add_subdirectory(login-plugins/login-complex)
add_subdirectory(tray-plugins/network)
#add_subdirectory(tray-plugins/webview)

=== debian/changelog ===
dde-session-shell (5.5.81-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 13 Oct 2022 19:40:50 +0800

## dde-session-shell 5.5.86

=== tests/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Test DBus REQUIRED)
find_package(GTest REQUIRED)
ADD_COMPILE_OPTIONS(-fno-access-control)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov -fno-access-control")

# 增加安全编译参数
set(SECURITY_COMPILE, "-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
set(CMAKE_CXX_FLAGS, "${CMAKE_CXX_FLAGS} ${SECURITY_COMPILE}")
set(CMAKE_C_FLAGS, "${CMAKE_C_FLAGS} ${SECURITY_COMPILE}")

# Address Sanitizer 内存错误检测工具,打开下面的编译选项可以看到调试信息，正常运行时不需要这些信息
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

add_subdirectory(dde-lock)
add_subdirectory(lightdm-deepin-greeter)

=== tests/dde-lock/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 set(BIN_NAME dde-lock-test)
 
 aux_source_directory(. LOCK_TEST)
-
-# 优先使用国密
-add_definitions(-DPREFER_USING_GM)
 
 set(LOCK_TEST_SRCS
     ${LOCK_TEST}

=== debian/changelog ===
dde-session-shell (5.5.86-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 24 Nov 2022 09:38:39 +0800
